/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import java.io.IOException;
import javax.swing.KeyStroke;
import objets.CMathGrafDoc;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionFichierNouvelleFigure extends MtgAction {
	public ActionFichierNouvelleFigure(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuFichierNouvelleFigure"),
				getString("chaineTipFichierNouvelleFigure"), MtgFrame.iconNouvelleFigure, KeyStroke.getKeyStroke("control N"));
	}
	
	@Override // Ajout version 4.3
  public boolean estDansBarreHorizontale() {
  	return true;
  }
	
	@Override
	public void actionPerformed(ActionEvent e) {
		// Spcial version Applet : on regarde si la figure prcdente a t modifie et si oui on demande confirmation
		if (frame.cadreActif().document.isDirty()) {
			if (!frame.dialogueConfirmation_YES_NO(getString("ch184"))) return;
		}
		// boolean maximise = cadreActif == null ? false : cadreActif.isMaximum(); Supprim version Applet	
		MtgInternalFrame cadreActif = frame.cadreActif();
		cadreActif.retireComposants(); // Ajout version 4.5.2
		CMathGrafDoc doc = new CMathGrafDoc(frame);
		cadreActif.setDocument(doc);
		cadreActif.creePaneAffichageVariables();	// Dtruira un ventuel panneau d'affichage de variables
		doc.listePrincipale.uniteAngle = frame.pref_angleUnit;
		doc.listePrincipale.ajouteConstantePi();
		doc.listePrincipale.ajouteSegmentLongueurUnite();
		// MtgInternalFrame cadre = new MtgInternalFrame(frame, doc);
		// Dimension sizefen = new Dimension(cadre.getWidth(), cadre.getHeight()); Supprim version Applet
		try {
			cadreActif.gestionnaire.initialise();
		} catch (IOException e1) {}
		frame.metAJourIconesEtMenus(cadreActif.document);
		/* Supprim version Applet
		frame.mtgDesktopPane.add(cadre);
		if (maximise) {
			try {
				cadre.setMaximum(true);
			} catch (PropertyVetoException e1) {
				frame.mtgDesktopPane.getDesktopManager().maximizeFrame(cadre);
			}
		}
		else {
			// Modification version 3.5.1
			frame.mtgDesktopPane.getDesktopManager().activateFrame(cadre);
			try {
				cadre.setSelected(true);
			} catch (PropertyVetoException e1) {
			}
			frame.preparePositionPourFenenetre(sizefen);
			cadre.setLocation(frame.xfenetre, frame.yfenetre);
		}
		*/
		// cadreActif.redessineAvecCalcul(); // Modifi version 4.7.2.1 pour envoyer un oordre repaint
		frame.recalculateAndRedraw(false);
		frame.activeOutilCapture();
		// On cre si ncessaire un item de menu dans le menu Fenetres pour activer cete fentre
		/* Supprim versin Applet
		int nfen = frame.nombreCadresOuverts();
		if (nfen <= MtgFrame.nombreFenetresDansMenu) {
			MtgMenuFileItem item = new MtgMenuFileItem(cadre);
			frame.menuFenetre.add(item);
		}
		else if (nfen == MtgFrame.nombreFenetresDansMenu + 1) frame.menuFenetre.add(frame.itemChoixFenetre);
		*/
	}
}
