/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import objets.CListeObjets;
import objets.CRepere;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionZoomPlus extends MtgAction {
	public static final double rapportZoomPlus = 1.2;
  public ActionZoomPlus(MtgFrame frameInit) {
    super(frameInit, null, getString("chaineMenuZoomPlus"), getString("chaineTipZoomPlus"), MtgFrame.iconZoomPlus, null);
  }
  
	@Override // Ajout version 4.3
  public boolean estDansBarreHorizontale() {
  	return true;
  }  
  
  @Override
  public int idMenu() {
    return 32905;
  }
  
	public void actionPerformed(ActionEvent e) {
		MtgInternalFrame cadre = frame.cadreActif();
		CListeObjets liste = cadre.listePr;
		double x = cadre.dimf.longueurAbscisses/2;
		double y = cadre.dimf.longueurOrdonnees/2;
		CRepere rep = liste.premierRepereVisible();
		if(rep != null) {
			x =  rep.O.x;
			y  = rep.O.y;
		}
		cadre.listePr.zoom(x, y, rapportZoomPlus);
		cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil94"));
		cadre.repaintFigureAvecCalcul();
	}
  
}
