/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class CodeHTMLDlg extends MtgDlg {
	private JLabel label1;
	private JTextArea areaCode;
	private JButton btnCopier, btnFermer;
	private JScrollPane scrollPane;
	
  public CodeHTMLDlg(MtgFrame frameInit) {
    super (getString("codeHTMLDlg1"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnFermer);    
  }
  
  private void initComponents() {
  	label1 = new JLabel(getString("codeHTMLDlg2"));
  	btnCopier = new JButton(getString("btnCopier"));
  	areaCode = new JTextArea();
  	// areaCode.setFont(FonteNom.getFonteNom(1, FonteNom.Normal, true));
  	areaCode.setText(codeHTML());
  	areaCode.setCaretPosition(0);
    scrollPane = new JScrollPane(areaCode, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	  btnFermer = new javax.swing.JButton(getString("btnFermer"));
	  btnFermer.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnFermerActionPerformed();
	    }
	  });
	  btnCopier = new javax.swing.JButton(getString("btnCopier"));
	  btnCopier.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnCopierActionPerformed();
	    }
	  });
	  
	  JPanel panePrincipal = (JPanel) getContentPane();
	  panePrincipal.setLayout(new GridBagLayout());
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 5;
		constraints.insets.top = 5;
		constraints.insets.left = 5;
		constraints.insets.right = 5;

		setConstraints(constraints, 0, 0, 1, 1, 80, 20, GridBagConstraints.NONE, GridBagConstraints.WEST);
		panePrincipal.add(label1, constraints);
		setConstraints(constraints, 0, 1, 2, 1, 0, 20, GridBagConstraints.BOTH, GridBagConstraints.WEST);
		panePrincipal.add(scrollPane, constraints);
		setConstraints(constraints, 0, 2, 2, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(btnCopier, constraints);
		setConstraints(constraints, 1, 0, 2, 1, 20, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
		panePrincipal.add(btnFermer, constraints);
		pack();		
  }
  
  private void btnFermerActionPerformed() {
  	dispose();
  }
  
  private void btnCopierActionPerformed() {
    Toolkit.getDefaultToolkit().getSystemClipboard().setContents
    	(new StringSelection(areaCode.getText()), null);

  }
  
  private String codeHTML() {
		MtgInternalFrame cadre = frame.cadreActif();  	
  	StringBuffer stb = new StringBuffer(256);
  	stb.append("<applet code=\"Applet.AppletMathGraph32.class\"");
  	stb.append("\n    " + "archive = \"AppletMathGraph32.jar\"");
  	stb.append("\n    " + "width=" + cadre.dimf.longueurAbscisses
  			+ "\n    height=" + cadre.dimf.longueurOrdonnees + ">");
  	String nomDoc = cadre.nomDocument();
  	stb.append("\n    " + "<param name= Path value = \"" + nomDoc + "\">");
  	stb.append("\n" + "</applet>");
  	return stb.toString();
  }
	

}
