/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import mathgraph32.MtgFrame;
import objets.CPrototype;
import types.FonteNom;

@SuppressWarnings("serial")
public class InformationConstructionDlg extends MtgDlg {
	private CPrototype proto;
	private JButton btnFermer;
	private JTextArea editeurInfoPrototype;
	private JScrollPane scrollPaneInfo;
	
  public InformationConstructionDlg(MtgFrame frameInit, CPrototype protoInit) {
  	super(getString("informationConstructionDlg1"), true, frameInit);
  	proto = protoInit;
  	initComponents();
		getRootPane().setDefaultButton(btnFermer);
  }  	
  	
  private void initComponents() {
	  btnFermer = new javax.swing.JButton(getString("btnFermer"));
	  btnFermer.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnFermerActionPerformed();
	    }
	  });
    editeurInfoPrototype = new JTextArea();
    editeurInfoPrototype.setFont(FonteNom.getFonteNom(2, FonteNom.Normal, -1));
    editeurInfoPrototype.setEditable(false);
    scrollPaneInfo = new JScrollPane(editeurInfoPrototype, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    editeurInfoPrototype.setColumns(20);
    editeurInfoPrototype.setLineWrap(false);
    editeurInfoPrototype.setRows(12);
    scrollPaneInfo.setPreferredSize(new Dimension(450, 240));
    String ch = proto.commentaire;
    int ind = ch.indexOf('#');
    if (ind != -1) ch = ch.substring(0,ind);
  	editeurInfoPrototype.setText(ch);
  	editeurInfoPrototype.setCaretPosition(0);
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    JPanel panePrincipal = (JPanel) getContentPane();
    panePrincipal.setLayout(new GridBagLayout());
    setConstraints(constraints, 0, 0, 1, 1, 80, 100, GridBagConstraints.BOTH, GridBagConstraints.WEST);
    panePrincipal.add(scrollPaneInfo, constraints);
    setConstraints(constraints, 1, 0, 1, 1, 20, 100, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    panePrincipal.add(btnFermer, constraints);
    
    pack();
  }
  
  private void btnFermerActionPerformed() {
  	dispose();
  }
	

}
