/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import objets.CListeObjets;
import objets.CMacro;
import types.FonteNom;
import types.NatureObjet;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ModificationMacroDlg extends MtgDlg {

		private JLabel label1, label2, label3;
		private ListeMacros listeMacros;
		private JScrollPane scrollPaneMacro;
		private JButton btnSupprimer, btnFermer, btnReclasserDebut, btnReclasserFin, btnModifier;
		private JButton btnMasquer, btnRendreVisible;
		private JTextArea infoCommentaire, info;
		private JScrollPane scrollPaneInfoCommentaire, scrollPaneInfo;
		
	public ModificationMacroDlg(MtgFrame frameInit) {
  	super(getString("modificationMacroDlg1"), true, frameInit);
  	initComponents();
    getRootPane().setDefaultButton(btnFermer);      	
  }
	
	private void initComponents() {
		label1 = new JLabel(getString("modificationMacroDlg2"));
    label2 = new JLabel(getString("InformationSurMacro"), JLabel.LEFT);
    label3 = new JLabel(getString("CommentaireMacro"), JLabel.LEFT);
  	btnFermer = new javax.swing.JButton(getString("btnFermer"));
  	btnFermer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnFermerActionPerformed();
      }
    });
  	btnSupprimer = new javax.swing.JButton(getString("btnSupprimer"));
  	btnSupprimer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnSupprimerActionPerformed();
      }
    });
  	btnReclasserDebut = new javax.swing.JButton(getString("btnReclasserDebut"));
  	btnReclasserDebut.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnReclasserDebutActionPerformed();
      }
    });
  	btnReclasserFin = new javax.swing.JButton(getString("btnReclasserFin"));
  	btnReclasserFin.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnReclasserFinActionPerformed();
      }
    });
  	btnModifier = new javax.swing.JButton(getString("btnModifier"));
  	btnModifier.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnModifierActionPerformed();
      }
    });
  	btnMasquer = new javax.swing.JButton(getString("btnMasquer"));
  	btnMasquer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnMasquerActionPerformed();
      }
    });
  	btnRendreVisible = new javax.swing.JButton(getString("btnRendreVisible"));
  	btnRendreVisible.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnRendreVisibleActionPerformed();
      }
    });
  	
  	btnFermer.setMaximumSize(btnReclasserDebut.getPreferredSize());
  	btnSupprimer.setMaximumSize(btnReclasserDebut.getPreferredSize());
  	btnModifier.setMaximumSize(btnReclasserDebut.getPreferredSize());
  	btnReclasserFin.setMaximumSize(btnReclasserDebut.getPreferredSize());
  	btnMasquer.setMaximumSize(btnReclasserDebut.getPreferredSize());
  	btnRendreVisible.setMaximumSize(btnReclasserDebut.getPreferredSize());
  	
  	// Spcial version applet
  	// CListeObjets liste = frame.cadreActif().listePr;
  	CListeObjets liste = frame.listePourConstruction();
		listeMacros = new ListeMacros(liste, liste.size() - 1);
    listeMacros.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
      	listeMacrosSelectionChanged();
      }
    });
   listeMacros.addMouseListener(new MouseListener() {

			public void mouseClicked(MouseEvent evt) {
				listeMacrosMouseClicked(evt);
			}

			public void mouseEntered(MouseEvent evt) {
			}

			public void mouseExited(MouseEvent evt) {
			}

			public void mousePressed(MouseEvent evt) {
			}

			public void mouseReleased(MouseEvent evt) {
			}
    });
    
    scrollPaneMacro = new JScrollPane(listeMacros, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);    
		infoCommentaire = new JTextArea();
		infoCommentaire.setFont(FonteNom.getFonteNom(2, FonteNom.Normal, -1));    
		infoCommentaire.setColumns(20);
		infoCommentaire.setLineWrap(false);
		infoCommentaire.setRows(4);
		infoCommentaire.setEditable(false);
    scrollPaneInfoCommentaire = new JScrollPane(infoCommentaire, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		info = new JTextArea();
		info.setFont(FonteNom.getFonteNom(2, FonteNom.Normal, -1));    
		info.setColumns(40);
		info.setLineWrap(true);
		info.setRows(2);
    scrollPaneInfo = new JScrollPane(info, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    
    JPanel panePrincipal = new JPanel();
    JPanel paneRight = new JPanel();
    panePrincipal.setLayout(new GridBagLayout());
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    setConstraints(constraints, 0, 0, 1, 1, 80, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    panePrincipal.add(label1, constraints);
    setConstraints(constraints, 0, 1, 1, 1, 0, 30, GridBagConstraints.BOTH, GridBagConstraints.WEST);
    panePrincipal.add(scrollPaneMacro, constraints);
    setConstraints(constraints, 0, 2, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    panePrincipal.add(label2, constraints);
    setConstraints(constraints, 0, 3, 1, 1, 0, 30, GridBagConstraints.BOTH, GridBagConstraints.WEST);
    panePrincipal.add(scrollPaneInfo, constraints);
    setConstraints(constraints, 0, 4, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
    panePrincipal.add(label3, constraints);
    setConstraints(constraints, 0, 5, 1, 1, 0, 30, GridBagConstraints.BOTH, GridBagConstraints.WEST);
    panePrincipal.add(scrollPaneInfoCommentaire, constraints);
    
    paneRight.add(btnFermer);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnSupprimer);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnReclasserDebut);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnReclasserFin);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnModifier);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnMasquer);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnRendreVisible);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    setConstraints(constraints, 2, 0, 1, 4, 20, 0, GridBagConstraints.NONE, GridBagConstraints.NORTH);
    panePrincipal.add(paneRight, constraints);
    setContentPane(panePrincipal);
    pack();
    listeMacrosSelectionChanged();
	}
	
	private void btnFermerActionPerformed() {
		dispose();
	}
	
	private void btnSupprimerActionPerformed() {
  	CMacro macro =listeMacros.macroChoisie();
  	MtgInternalFrame cadre = frame.cadreActif();
  	// Spcial version applet
  	// CListeObjets liste = cadre.listePr;
  	CListeObjets liste = frame.listePourConstruction();
  	int ind = liste.indexOf(macro);
  	boolean suppression = false;
  	if (liste.nombreDependants(macro) >= 2) {
      if (frame.dialogueConfirmation_YES_NO(getString("ch37"))) {
        frame.retireDependants(macro);
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil119"));
        suppression = true;
      }      
    }
    else {
      frame.retireDependants(macro);
      cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil119"));
      cadre.effacegbuffer();
      cadre.repaintFigureSansCalcul();
      suppression = true;
    }
  	if (suppression) {
      int nb = liste.nombreObjetsParNatureGraphiqueNonIntermediaires(NatureObjet.NMacro);
      if (nb == 0) {
      	cadre.effacegbuffer();
        cadre.repaintFigureSansCalcul();
      	dispose();
      	return;
      }
      listeMacros.metAJourIndiceMaxi(liste.size() - 1);
      listeMacros.metAJourListe();
      if (ind >= nb) ind --;
      cadre.effacegbuffer();
      cadre.repaintFigureSansCalcul();
      listeMacros.setSelectedIndex(ind);
      listeMacrosSelectionChanged();
  	}		
	}
	
	private void btnReclasserDebutActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	// Spcial version applet
  	// CListeObjets liste = cadre.listePr;
  	CListeObjets liste = frame.listePourConstruction();
  	CMacro macro =listeMacros.macroChoisie();
  	if (liste.reclasseVersDebutAvecDependants(macro)) {
  		dialogueAvertissement(getString("reclassementDebutObjetGraphique2"));
			cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil102"));
			cadre.repaintFigureAvecCalcul();
			listeMacros.metAJourListe();
  	}
  	else dialogueAvertissement(getString("reclassementDebutObjetGraphique3"));  		
		
	}
	
	private void btnReclasserFinActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	// Spcial version applet
  	// CListeObjets liste = cadre.listePr;
  	CListeObjets liste = cadre.listePr;
  	CMacro macro =listeMacros.macroChoisie();
  	if (liste.reclasseVersFinAvecDependants(macro)) {
  		dialogueAvertissement(getString("reclassementFinObjetGraphique2"));
			cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil98"));
			cadre.repaintFigureAvecCalcul();
			listeMacros.metAJourListe();
	 }
	 else dialogueAvertissement(getString("reclassementFinObjetGraphique3"));  		
		
	}
	
	private void btnModifierActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CMacro macro =listeMacros.macroChoisie();
    if (macro.modifiableParMenu()) {
    	MtgDlg dlg = macro.dialogueModification(frame);
    	dlg.setLocationRelativeTo(this);
    	dlg.setVisible(true);
    	if (dlg.retourOK()) {
    		cadre.repaintFigureAvecCalcul();
    		listeMacros.metAJourListe();
    	}
    }
	}
	
  private void btnMasquerActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CMacro macro =listeMacros.macroChoisie();
  	macro.masque = true;
		cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil120"));
		cadre.repaintFigureAvecCalcul();
		btnMasquer.setVisible(false);
		btnRendreVisible.setVisible(true);
		pack();
  }
  
  private void btnRendreVisibleActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CMacro macro =listeMacros.macroChoisie();
  	macro.masque = false;
		cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil121"));
		cadre.repaintFigureAvecCalcul();
		btnMasquer.setVisible(true);
		btnRendreVisible.setVisible(false);
		pack();
  }
    
  public void listeMacrosMouseClicked(MouseEvent evt) {
  	if ((evt.getClickCount() == 2) && (listeMacros.getSelectedIndex() != -1)) btnModifierActionPerformed();
  }
	
  private void listeMacrosSelectionChanged() {
  	int i = listeMacros.getSelectedIndex();
  	if (i != -1) {
  		CMacro mac = listeMacros.macroChoisie();
  		infoCommentaire.setText(mac.commentaireMacro);
  		infoCommentaire.setCaretPosition(0);
  		info.setText(mac.infoPourHistorique());
  		info.setCaretPosition(0);
  		if (mac.masque) {
  			btnRendreVisible.setVisible(true);
  			btnMasquer.setVisible(false);
  			pack();
  		}
  		else {
  			btnRendreVisible.setVisible(false);
  			btnMasquer.setVisible(true);
  			pack();
  		}
  	}
  }
	
}
