/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PaneDuree extends JPanel {
	public JList<String> liste;
	public PaneDuree(int dureeInit) {
		super();
		liste= new JList<String>();
		Vector<String> vec = new Vector<String>();
		vec.add(MtgFrame.getString("paneDuree2")); // Pour une pause jusqu' un clic de souris
		for (int i = 1; i <= 30; i++) {
			vec.add(Integer.toString(i));
		}
		liste.setListData(vec);
    liste.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    liste.setLayoutOrientation(JList.VERTICAL);
    liste.setVisibleRowCount(5);
    liste.setSelectedIndex(dureeInit);
    JLabel label1 = new JLabel(MtgFrame.getString("paneDuree3"));
    add(label1);
    JScrollPane scrollpane = new JScrollPane(liste, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    add(scrollpane);
    liste.ensureIndexIsVisible(liste.getSelectedIndex());
    setBorder(BorderFactory.createTitledBorder(MtgFrame.getString("paneDuree1")));
	}
	
	public final int dureeChoisie() {
		return liste.getSelectedIndex();
	}
}
