/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;
import java.awt.FlowLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import mathgraph32.MtgFrame;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class PremierDernierDlg extends MtgDlg {
  private javax.swing.JButton btnCancel;
  private javax.swing.JButton btnOK;
  private javax.swing.ButtonGroup btnGroup;
  private javax.swing.JLabel label1;
  private javax.swing.JLabel label2;
  private javax.swing.JPanel paneLeft;
  private javax.swing.JPanel paneRight;
  private javax.swing.JPanel panePrincipal;
  private javax.swing.JRadioButton rdioBtnDernier;
  private javax.swing.JRadioButton rdioBtnPremier;
  
  public PremierDernierDlg(MtgFrame frameInit) {
    super (getString("ch103"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);
  }

  private void initComponents()  {
    btnGroup = new javax.swing.ButtonGroup();
    label1 = new javax.swing.JLabel(getString("premierDernierDlg1"));
    label2 = new javax.swing.JLabel(getString("premierDernierDlg2"));
    rdioBtnPremier = new javax.swing.JRadioButton(getString("premierDernierDlg3"));
    rdioBtnPremier.setSelected(true);
    rdioBtnDernier = new javax.swing.JRadioButton(getString("premierDernierDlg4"));
    paneLeft = new javax.swing.JPanel();
    paneRight = new javax.swing.JPanel();
    panePrincipal = new javax.swing.JPanel();
    btnOK = new javax.swing.JButton(getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new javax.swing.JButton(getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    btnOK.setMaximumSize(btnCancel.getPreferredSize());
    btnGroup.add(rdioBtnPremier);
    btnGroup.add(rdioBtnDernier);
    paneLeft.setLayout(new BoxLayout(paneLeft, BoxLayout.Y_AXIS));
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneLeft.add(label1);
    paneLeft.add(label2);
    paneLeft.add(rdioBtnPremier);
    paneLeft.add(rdioBtnDernier);
    rdioBtnDernier.setSelected(true);
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    panePrincipal.setLayout(new FlowLayout());
    panePrincipal.add(paneLeft);
    panePrincipal.add(paneRight);
    setContentPane(panePrincipal);
    pack();    
  }
  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) { 
    dispose ();
  }                                         

  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {                                      
    // Si la rponse est valide, on ferme la boite de dialogue sans la dtruire.
    //setVisible(false); 
    dispose();
    //La boite de dialogue existera toujours ce qui permettra de connaitre le contneu
    // de retourOK
    setRetourOK(true);
  }                                     
  public boolean getPremierChoisi ()
  {
    return rdioBtnPremier.isSelected();
  }
}
