/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JPanel;
import javax.swing.JToolBar;

import dialogs.MtgDlg;

@SuppressWarnings("serial")
public class MtgPaneChoixCouleur extends JPanel implements MouseListener  {
	private MtgFrame frame;
	private static Insets ins = new Insets(0, 0, 0, 0);
	JToolBar barCouleur1;
	JToolBar barCouleur2;
	JToolBar barCouleur3;
	JToolBar barCouleur4;
	JToolBar barCouleur5;
	JToolBar barCouleur6;
	JToolBar barCouleur7;
	JToolBar barCouleur8;
	
  public MtgPaneChoixCouleur(MtgFrame frameInit) {
    super();
    frame = frameInit;
  	// 16 boutons de choix de couleur prdfinie
		MtgOneColorButton oneColorButton1 = new MtgOneColorButton(frame, new Color(0, 0, 0));
		MtgOneColorButton oneColorButton2 = new MtgOneColorButton(frame, new Color(0, 0, 255));
		MtgOneColorButton oneColorButton3 = new MtgOneColorButton(frame, new Color(0, 255, 0));
		MtgOneColorButton oneColorButton4 = new MtgOneColorButton(frame, new Color(255, 0, 0));
		MtgOneColorButton oneColorButton5 = new MtgOneColorButton(frame, new Color(0, 255, 255));
		MtgOneColorButton oneColorButton6 = new MtgOneColorButton(frame, new Color(255, 0, 255));
		MtgOneColorButton oneColorButton7 = new MtgOneColorButton(frame, new Color(255, 255, 0));
		MtgOneColorButton oneColorButton8 = new MtgOneColorButton(frame, new Color(127, 127, 127));
		MtgOneColorButton oneColorButton9 = new MtgOneColorButton(frame, new Color(0, 0, 127));
		MtgOneColorButton oneColorButton10 = new MtgOneColorButton(frame, new Color(0, 127, 0));
		MtgOneColorButton oneColorButton11 = new MtgOneColorButton(frame, new Color(127, 0, 0));
		MtgOneColorButton oneColorButton12 = new MtgOneColorButton(frame, new Color(0, 127, 127));
		MtgOneColorButton oneColorButton13 = new MtgOneColorButton(frame, new Color(127, 0, 127));
		MtgOneColorButton oneColorButton14 = new MtgOneColorButton(frame, new Color(127, 127, 0));
		MtgOneColorButton oneColorButton15 = new MtgOneColorButton(frame, new Color(102, 102, 102));
		MtgOneColorButton oneColorButton16 = new MtgOneColorButton(frame, new Color(51, 51, 51));    
		// Les 4 barres d'outils verticales servant  contenr les 14 boutons
		// de couleurs prdfinies.
		barCouleur1 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur2 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur3 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur4 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur5 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur6 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur7 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur8 = new JToolBar(JToolBar.HORIZONTAL);
		barCouleur1.setMargin(ins);
		barCouleur2.setMargin(ins);
		barCouleur3.setMargin(ins);
		barCouleur4.setMargin(ins);
		barCouleur5.setMargin(ins);
		barCouleur6.setMargin(ins);
		barCouleur7.setMargin(ins);
		barCouleur8.setMargin(ins);
		barCouleur1.setFloatable(false);
		barCouleur2.setFloatable(false);
		barCouleur3.setFloatable(false);
		barCouleur4.setFloatable(false);
		barCouleur5.setFloatable(false);
		barCouleur6.setFloatable(false);
		barCouleur7.setFloatable(false);
		barCouleur8.setFloatable(false);
		barCouleur1.add(oneColorButton1);
		barCouleur1.add(oneColorButton2);
		barCouleur2.add(oneColorButton3);
		barCouleur2.add(oneColorButton4);
		barCouleur3.add(oneColorButton5);
		barCouleur3.add(oneColorButton6);
		barCouleur4.add(oneColorButton7);
		barCouleur4.add(oneColorButton8);
		barCouleur5.add(oneColorButton9);
		barCouleur5.add(oneColorButton10);
		barCouleur6.add(oneColorButton11);
		barCouleur6.add(oneColorButton12);
		barCouleur7.add(oneColorButton13);
		barCouleur7.add(oneColorButton14);
		barCouleur8.add(oneColorButton15);
		barCouleur8.add(oneColorButton16);
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 0;
		constraints.insets.top = 0;
		constraints.insets.left = 0;
		constraints.insets.right = 0;		
		setLayout(new GridBagLayout());
		MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 50, 100,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur1, constraints);
		MtgDlg.setConstraints(constraints, 0, 1, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur2, constraints);
		MtgDlg.setConstraints(constraints, 0, 2, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur3, constraints);
		MtgDlg.setConstraints(constraints, 0, 3, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur4, constraints);
		MtgDlg.setConstraints(constraints, 0, 4, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur5, constraints);
		MtgDlg.setConstraints(constraints, 0, 6, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur6, constraints);
		MtgDlg.setConstraints(constraints, 0, 7, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur7, constraints);
		MtgDlg.setConstraints(constraints, 0, 8, 1, 1, 50, 0,
				GridBagConstraints.NONE, GridBagConstraints.WEST);
		add(barCouleur8, constraints);
	}
	
  public Dimension taillePourScrollPane() {
  	Dimension d = barCouleur1.getPreferredSize();
  	return new Dimension(d.width, d.height*3 + 4);
  }
  
  public int verticalIncrement() {
  	return barCouleur1.getPreferredSize().height*2;
  }  
  
	public void mouseClicked(MouseEvent arg0) {
	}  
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}  
  
	
}
