/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JToolBar;

import types.StyleMarqueSegment;

@SuppressWarnings("serial")
public class MtgPaneStyleMarqueSegment extends JPanel implements MouseListener {
	private MtgFrame frame;
	private static Insets ins = new Insets(0, 0, 0, 0);
	private JToolBar barStyleMarqueSegment1;
	private JToolBar barStyleMarqueSegment2;
	
  public MtgPaneStyleMarqueSegment(MtgFrame frameInit) {
    super();
    frame = frameInit;
  	// Des boutons servant  dterminer le style des marques de segments cres
		MtgStyleMarqueSegmentButton buttonStyleMarqueSegment1 = new MtgStyleMarqueSegmentButton(frame, StyleMarqueSegment.marqueSegment1);
		MtgStyleMarqueSegmentButton buttonStyleMarqueSegment2 = new MtgStyleMarqueSegmentButton(frame, StyleMarqueSegment.marqueSegment2);
		MtgStyleMarqueSegmentButton buttonStyleMarqueSegment3 = new MtgStyleMarqueSegmentButton(frame, StyleMarqueSegment.marqueSegment3);
		MtgStyleMarqueSegmentButton buttonStyleMarqueSegment4 = new MtgStyleMarqueSegmentButton(frame, StyleMarqueSegment.marqueSegment4);
  	// Les deux barres d'outils horizontales servant  contenir les icnes de
  	// choix de style de marque de segment
  	barStyleMarqueSegment1 = new JToolBar(JToolBar.HORIZONTAL);
  	barStyleMarqueSegment2 = new JToolBar(JToolBar.HORIZONTAL);
		barStyleMarqueSegment1.setMargin(ins);
		barStyleMarqueSegment2.setMargin(ins);
		barStyleMarqueSegment1.setFloatable(false);
		barStyleMarqueSegment2.setFloatable(false);

  	// Un groupe de boutons pour englober tous les boutons de la barre d'outil de
  	// choix de style de segement
  	ButtonGroup btngroupStyleMarqueSegment = new ButtonGroup();
		btngroupStyleMarqueSegment.add(buttonStyleMarqueSegment1);
		btngroupStyleMarqueSegment.add(buttonStyleMarqueSegment2);
		btngroupStyleMarqueSegment.add(buttonStyleMarqueSegment3);
		btngroupStyleMarqueSegment.add(buttonStyleMarqueSegment4);
		// On active la marque simple comme marque de segment par dfaut
		buttonStyleMarqueSegment1.setSelected(true);
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		barStyleMarqueSegment1.add(buttonStyleMarqueSegment1);
		barStyleMarqueSegment1.add(buttonStyleMarqueSegment2);
		barStyleMarqueSegment2.add(buttonStyleMarqueSegment3);
		barStyleMarqueSegment2.add(buttonStyleMarqueSegment4);
		barStyleMarqueSegment1.setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 1));
		barStyleMarqueSegment2.setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 1));
		add(barStyleMarqueSegment1);
		add(barStyleMarqueSegment2);
		setBorder(BorderFactory.createEtchedBorder());		
		
  }

  public Dimension taillePourScrollPane() {
  	Dimension d = barStyleMarqueSegment1.getPreferredSize();
  	return new Dimension(d.width, d.height + 10);
  }
  
  public int verticalIncrement() {
  	return barStyleMarqueSegment1.getPreferredSize().height;
  }  
  
	public void mouseClicked(MouseEvent arg0) {
	}  
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}  
  
}
