/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JToolBar;

import types.StyleRemplissage;

@SuppressWarnings("serial")
public class MtgPaneStyleRemplissage extends JPanel implements MouseListener {
	private MtgFrame frame;
	private static Insets ins = new Insets(0, 0, 0, 0);  
  private JToolBar bar1 = new JToolBar(JToolBar.HORIZONTAL);
  private JToolBar bar2 = new JToolBar(JToolBar.HORIZONTAL);
  private JToolBar bar3 = new JToolBar(JToolBar.HORIZONTAL);
	
	public MtgPaneStyleRemplissage(MtgFrame frameInit) {
    super();
    frame = frameInit;
  	// Les deux barres d'outils horizontales servant  contenir les icnes de
  	// choix de style de flche
    bar1 = new JToolBar(JToolBar.HORIZONTAL);
    bar2 = new JToolBar(JToolBar.HORIZONTAL);
    bar3 = new JToolBar(JToolBar.HORIZONTAL);
    // Les six boutons
    MtgStyleRemplissageButton button1 = new MtgStyleRemplissageButton(frame, StyleRemplissage.QuadrillagePleinTransp);
    MtgStyleRemplissageButton button2 = new MtgStyleRemplissageButton(frame, StyleRemplissage.QuadrillagePlein);
    MtgStyleRemplissageButton button3 = new MtgStyleRemplissageButton(frame, StyleRemplissage.Quadrillage45Bas);
    MtgStyleRemplissageButton button4 = new MtgStyleRemplissageButton(frame, StyleRemplissage.Quadrillage45Haut);
    MtgStyleRemplissageButton button5 = new MtgStyleRemplissageButton(frame, StyleRemplissage.QuadrillageHorizontal);
    MtgStyleRemplissageButton button6 = new MtgStyleRemplissageButton(frame, StyleRemplissage.QuadrillageVertical);
  	// Un groupe de boutons pour englober tous les boutons de la barre d'outil de
  	// choix de style de point
  	ButtonGroup btngroup = new ButtonGroup();
		bar1.setMargin(ins);
		bar2.setMargin(ins);
		bar3.setMargin(ins);
		bar1.setFloatable(false);
		bar2.setFloatable(false);
		bar3.setFloatable(false);
		btngroup.add(button1);
		btngroup.add(button2);
		btngroup.add(button3);
		btngroup.add(button4);
		btngroup.add(button5);
		btngroup.add(button6);
		// On active par dfaut le remplissage plein aevc transparence
		button1.setSelected(true);
		bar1.add(button1);
		bar1.add(button2);
		bar2.add(button3);
		bar2.add(button4);
		bar3.add(button5);
		bar3.add(button6);
		bar1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		bar2.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		bar3.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(bar1);
		add(bar2);
		add(bar3);
	}

  public Dimension taillePourScrollPane() {
  	Dimension d = bar1.getPreferredSize();
  	return new Dimension(d.width, d.height*2 + 6);
  }
  
  public int verticalIncrement() {
  	return bar1.getPreferredSize().height + 1;
  }  
	
	public void mouseClicked(MouseEvent arg0) {
	}  
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}  
	
}
