/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;
import types.*;

/**
 *
 * @author Yves
 */
public class CAppelFonctionComplexe extends CAppelFonction{
  // Attribut utilis pour optimisation
  Complexe z1loc = new Complexe();
  /** Creates a new instance of CAppelFonctionComplexe */
  public CAppelFonctionComplexe() {
  }
  /** Constructeur */
  CAppelFonctionComplexe(CListeObjets liste, CCalculAncetre fonctionInit, CCalculBase operandeInit)
  {
    super(liste, fonctionInit, operandeInit);
  }
  
  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CCalculBase cloneOperande = operande.getClone(listeSource, listeCible); 
    //  revoir car la fonction a dj t cre
    int ind1 = listeSource.indexOf(fonctionAssociee);    
    CCalculBase ptcalc = new CAppelFonctionComplexe(listeCible, (CCalculAncetre)(listeCible.get(ind1, CCalculAncetre.class)),
      cloneOperande);
    return ptcalc;
  }
  // Ajout pour la version 2.0 calculs sur les complexes.
  // Le rsultat est renvoy dans z
  @Override
  public void resultatComplexe(boolean infoRandom, Complexe zRes) throws ErreurCalculException{
    operande.resultatComplexe(infoRandom, z1loc);
    fonctionAssociee.rendValeurFonctionComplexe(infoRandom, z1loc, zRes);
  }
  /// Sera redfinie pour tous les descendants pouvant ne pas exister
  @Override
  void  resultatFonctionComplexe(boolean infoRandom, Complexe valeurParametre, Complexe zRes)
    throws ErreurCalculException 
  {
    operande.resultatFonctionComplexe(infoRandom, valeurParametre, z1loc);
    fonctionAssociee.rendValeurFonctionComplexe(infoRandom, z1loc, zRes);
  }
  
  @Override
  void  resultatFonctionComplexe(boolean infoRandom,Complexe[] valeurParametre, Complexe zRes)
    throws ErreurCalculException 
  {
    operande.resultatFonctionComplexe(infoRandom, valeurParametre, z1loc);
    fonctionAssociee.rendValeurFonctionComplexe(infoRandom, z1loc, zRes);
  }
  
  public CCalculBase getCopie() {
    return new CAppelFonctionComplexe(listeProprietaire,fonctionAssociee, operande.getCopie());
  }
  
  // Ajout version 4.6
  @Override
  public CCalculBase calculAvecValeursRemplacees() {
  	return new CAppelFonction(listeProprietaire, fonctionAssociee, operande.calculAvecValeursRemplacees());
  }
  
 
}
