/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import objets.CMathGrafDoc;
import objets.CPrototype;
import dialogs.ChoixPrototypeFigureDlg;

public class OutilConstructionSupprimer extends Outil {

	CPrototype proto;
	
	public OutilConstructionSupprimer(MtgFrame frameInit) {
    super(frameInit, false);
  }
	
  @Override
	public void select() {
    super.select();
    boolean choixProto = choixProto();
    if (!choixProto) {
    	frame.activeOutilCapture();
    	return;
    }
    // On demande confirmation
    if (frame.dialogueConfirmation_YES_NO(getString("ch152"))) {
    	CMathGrafDoc doc = frame.cadreActif().document;
    	doc.tablePrototypes.remove(proto);
    }
    frame.activeOutilCapture();
	}

	protected boolean choixProto() {
		ChoixPrototypeFigureDlg dlg = new ChoixPrototypeFigureDlg(frame, getString("btnSupprimer"), getString("choixPrototypeFigureDlg5"));
		dlg.setLocationRelativeTo(null);
		dlg.setVisible(true);
		if (dlg.retourOK()) proto = dlg.prototypeChoisi;
		return dlg.retourOK();
	}

  @Override
  public boolean activationValide() {
    return frame.cadreActif().document.tablePrototypes.size()!= 0;
  }
  
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeConstruction");
	}		
}
