/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CIntegrale;
import objets.CListeObjets;
import objets.CValeurAssocieeAVariable;
import types.NatureCalcul;
import dialogs.IntegraleDlg;

public class OutilIntegrale extends Outil {
  public OutilIntegrale(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
	public boolean activationValide() {
		// return (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NFonction)!=0);
		return (frame.listePourConstruction().nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NFonction)!=0);
	}  
  
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeFonction");
	}	
	
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    CValeurAssocieeAVariable vala = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable valb = new CValeurAssocieeAVariable(liste, 0);
    CValeurAssocieeAVariable valn = new CValeurAssocieeAVariable(liste, 0);
    CIntegrale integrale = new CIntegrale(liste, null, false, "", null, vala, valb, valn);    
    IntegraleDlg dlg = new IntegraleDlg(frame, integrale, false);
		dlg.setLocationRelativeTo(null);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(integrale))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil80"));    	
    }
    frame.activeOutilCapture();
  } 
}
