/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import java.awt.Cursor;
import java.awt.Point;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CAffichageLieAPoint;
import objets.CCommentaire;
import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CMacroModeTraceActivation;
import types.StyleEncadrement;
import dialogs.MacroModeTraceActivationDlg;

public class OutilMacroModeTraceActivation extends Outil {

	public OutilMacroModeTraceActivation(MtgFrame frameInit) {
		super(frameInit, true);
	}

	@Override
	public Cursor curseurUtilise() {
		return MtgFrame.cornerCursor;
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageClic;
		frame.indication(getString("macro1"));
	}

	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		int x = pointClique.x;
		int y = pointClique.y;
		MtgInternalFrame cadre = frame.cadreActif();
		CListeObjets liste = cadre.listePr;
		// Avant l'affichage du dialogue on cre un message qui sera ajout  la
		// liste des objets clignotants
		// pour matrialiser l'emplacement de l'affichage
		CCommentaire comClignotant = new CCommentaire(liste, null, false, frame.couleurActive(), x, y, 0d, 0d,
				false, null, 2, StyleEncadrement.Sans, false, frame.cadreActif().couleurFond, getString("ch80"),
				CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
    comClignotant.positionne(false, frame.cadreActif().dimf);
		ajouteClignotementDe(comClignotant);
		resetClignotement();
		CMacroModeTraceActivation macro = new CMacroModeTraceActivation(liste, null, false, frame.couleurActive(), x, y, 0d, 0d,
				false, null, 2, false, cadre.couleurFondAffichage, "", "", CAffichageLieAPoint.alignementHorizontalGauche,
				CAffichageLieAPoint.alignementVerticalHaut);
		frame.indication("");
		MacroModeTraceActivationDlg dlg = new MacroModeTraceActivationDlg(frame, macro, false);
		dlg.setLocationRelativeTo(null);
		dlg.setVisible(true);
		if (dlg.retourOK()) {
			annuleClignotement();
			if (frame.ajouteElementAvecVerification(macro)) {
				frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil91"));
				frame.cadreActif().repaintFigureAvecCalcul();
			}
			frame.activeOutilCapture();
		} else {
			annuleClignotement();
			frame.activeOutilCapture();
		}
	}	
}
