/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CElementGraphique;
import objets.CMacroAnimationPointLie;
import objets.CPointLie;
import types.NatureObjet;

public class OutilMouvoirAnimationPointLie extends Outil {
	CPointLie pointlie;
	
	public OutilMouvoirAnimationPointLie(MtgFrame frameInit) {
		super(frameInit, true);
	}
		
  @Override
	public void select() {
		super.select();
		pointlie = null;
		frame.outilPointageActif = frame.outilPointageObjetClignotant;
		frame.outilPointageActif.designationDe(NatureObjet.NPointLie);
  	frame.listeClignotante.ajouteObjetsParNature(frame.cadreActif().listePr,NatureObjet.NPointLie);
		frame.indication(getString("mouvoirPointLie1"));
    frame.outilPointageObjetClignotant.reset();
	}
	
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (pointlie == null) {
    	annuleClignotement();
    	MtgInternalFrame cadre = frame.cadreActif();
    	cadre.videDesignation();
      pointlie = (CPointLie) elg;
      CMacroAnimationPointLie macroAnimation = cadre.macroAnimation;
      // Ligne suivante ncessaire car une lors d'une annulation d'action la liste a t recharge
      macroAnimation.listeProprietaire = cadre.listePr;
      macroAnimation.nombrePointsPourAnimation = frame.pref_moveNbPoints;
      macroAnimation.frequenceAnimationMacro = frame.pref_moveFreq;
      macroAnimation.animationCyclique = frame.pref_moveCyclic;
      macroAnimation.pointLieAssocie = pointlie;
      macroAnimation.metAJour();
      cadre.macroEnCours = macroAnimation;
      macroAnimation.initialiseInterruptions(cadre);
      macroAnimation.actionAvantExecution(cadre);
      frame.outilPointageActif=frame.outilPointageExecutionMacro;
    }
	}
	
}
