package outils;

import java.awt.Color;
import java.awt.Point;
import javax.swing.BorderFactory;

import mathgraph32.MtgButton;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CElementBase;
import objets.CElementGraphique;
import types.FonteNom;

public class OutilPropSol extends Outil {
  int indiceObjetEnCours;
  /**
   * Constructeur
   * @param appletMereInit
   */
  public OutilPropSol(MtgFrame frameInit) {
    super(frameInit, true);
  }
  
  public String toolTip() {
    return getString("toolTipPropSol");
  }
  
  public String chaineIndication (int indEtape) {
    return getString("ch8") + " " + frame.indicationSol(indEtape);
  }
  
    /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    indiceObjetEnCours = 1;
    frame.discardSolutionSubmitted();
    CElementBase elb =(CElementBase) cadre.listeAConstruire.get(0);
    frame.outilPointageActif = frame.outilPointagePropSol;
    frame.outilPointageActif.reset();
    frame.outilPointageActif.designationDe(elb.naturePourConst());
    frame.indication(chaineIndication(1));
  }
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
  	MtgInternalFrame cadre = frame.cadreActif();
    cadre.listeProposee.add(elg);
    ajouteClignotementDe(elg);
    resetClignotement();
    indiceObjetEnCours++;
    if (indiceObjetEnCours <= cadre.listeAConstruire.size()) {
      CElementBase elb =(CElementBase) cadre.listeAConstruire.get(indiceObjetEnCours-1);
      // Bug corrig version 4.7.2.7
      // frame.outilPointageActif.designationDe(elb.getNature());
      frame.outilPointageActif.designationDe(elb.naturePourConst());
      frame.indication(chaineIndication(indiceObjetEnCours));
   }
    else creeObjet();
  }
  /* On va maintenant regarder si les objets cliqus sont les bons */
  public void creeObjet() {
    frame.constructionExacte = frame.reponseValide();
    annuleClignotement();
    frame.activeOutilCapture();
    frame.indication(getString("validationSol"));
    // frame.dialogueAvertissement(Boolean.toString(frame.constructionExacte)); // Pour test
  }
  
  /**
   * 
   * @return Renvoie un pointeur sur le bouton correspondant  l'outil cr
   * ou null si l'outil est interdit pour la figure
   * Est redfini pour cet outil car il n'est pas dfini  partir d'un gif
   */
  // Modifi version 3.1.1
  public MtgButton boutonAssocie() {
    // Si l'item de l'outil est 0, c'est que le bouton correspondant
    // doit figurer toujours dans la barre d'outils
    MtgButton button = new MtgButton(frame.actionPropSol);
    button.setText(" "+ getString("solution") + " "); // Rajout version 4.7.2 xar dans le constructeur setText est mis  ""
    button.setBorder(BorderFactory.createMatteBorder(1, 2, 1, 2, Color.blue));
    button.setForeground(Color.blue);
    button.setFont(FonteNom.getFonteNom(5, FonteNom.Gras, -1));      
    button.setToolTipText(toolTip());
    return button;
  }
  
}