/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CElementGraphique;
import types.NatureObjet;

public class OutilRideau extends Outil {
	CElementGraphique objetDesigne;
	
	/** Creates a new instance of OutilPtLib */
	public OutilRideau(MtgFrame frameInit) {
		super(frameInit, false);
	}
	
  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointagePourRideau;
		frame.outilPointageActif.designationDe(NatureObjet.NToutObjet - NatureObjet.NMacro);
		frame.indication(getString("demasquerObjet1"));
		MtgInternalFrame cadre = frame.cadreActif();
		// Spcial version Applet
		cadre.listeSauve.setClone(cadre.listePr);
		if (cadre != null) {
			cadre.effacegbuffer();
			// cadre.listePr.afficheTout(cadre.gbuffer, cadre.dimf, false);
			cadre.masquageObjetsCaches =  false;
			cadre.repaintFigureSansCalcul();
		}
		frame.outilPointagePourRideau.aRedessinerDansPaint = true;
	}
	
  @Override
	public void deselect() {
		super.deselect();
		MtgInternalFrame cadre = frame.cadreActif();
		if (cadre != null) {
			cadre.masquageObjetsCaches = true;
			cadre.repaintFigureSansCalcul();
		}
	}
	
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		MtgInternalFrame cadre = frame.cadreActif();
		objetDesigne = elg;
		objetDesigne.montre();
		cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil68"));
		frame.outilPointagePourRideau.aRedessinerDansPaint = true; // Spcial applet
		cadre.repaintFigureAvecCalcul();
	}
}
