/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CListeObjets;
import objets.CSomme;
import objets.CValeurAssocieeAVariable;
import types.NatureCalcul;
import dialogs.SommeIndiceeDlg;

public class OutilSomme extends Outil {
  public OutilSomme(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets listePr = cadre.listePr;
    frame.indication("");
    CSomme somme = new CSomme(listePr, null, false, "", null, null,
    		new CValeurAssocieeAVariable(listePr, 0d), new CValeurAssocieeAVariable(listePr, 0d));   
    SommeIndiceeDlg dlg = new SommeIndiceeDlg(frame, somme, false);
		dlg.setLocationRelativeTo(null);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(somme))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil87"));    	
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
		return (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NVariable) != 0);
	}
  
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeVariable");
	}		
	
}
