/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CListeObjets;
import objets.CSuiteRec3;
import objets.CValeurAssocieeAVariable;
import types.NatureCalcul;
import dialogs.SuiteRecurrenteReelle3Dlg;

public class OutilSuiteRecurrenteReelle3 extends Outil {

	public OutilSuiteRecurrenteReelle3(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    frame.indication("");
    CSuiteRec3 suite = new CSuiteRec3(frame.cadreActif().listePr,	new CValeurAssocieeAVariable(liste, 10d),
    		new CValeurAssocieeAVariable(liste,0d), new CValeurAssocieeAVariable(liste,0d));
    SuiteRecurrenteReelle3Dlg dlg = new SuiteRecurrenteReelle3Dlg(frame, suite, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(suite))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil73"));    	
    	
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NFonction3Var) != 0;
	}
		
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeFonctionReelle3Var");
	}	

}
